import CSLib.*;

public class Scores {
  // Read scores and compute the minimum, maximum, and average
  // scores.  Scores are read until the user enters the "empty"
  // input value.
  // Author: Arthur L. Reingold, October 31, 1994.

  int sumOfScores = 0,
      numberOfScores = 0,
      maxOfScores = -1,    // phony max score 
      minOfScores = 999;   // phony min score

  public void compute () {

    int score;

    InputBox in = new InputBox();
    in.setPrompt("Enter score (empty input ends the data): ");
  
    while (true) {
      score = in.readInt();
      if (in.eoi()) break;
      numberOfScores++;                   // new score
      sumOfScores = sumOfScores + score;  // update sum
      if (maxOfScores < score)            // new largest score
        maxOfScores = score;
      if (minOfScores > score)            // new smallest score
        minOfScores = score;
  
      // numberOfScores is the number of scores read 
      // so far and sumOfScores is their sum; maxOfScores 
      // is the largest score and minOfScores is the smallest
      // score read so far
  
    }
  }
  
  public void print () {  
    OutputBox out = new OutputBox();
    if (numberOfScores == 0)
      out.println("No scores were entered.");
    else if (numberOfScores == 1)
      out.println("Only one score was entered.  It was "
           + sumOfScores);
    else {
      out.println(numberOfScores + " scores were entered.");
      out.println("The average score was "
          + ((double)sumOfScores)/numberOfScores);
      out.println("The maximum score was " + maxOfScores);
      out.println("The minimum score was " + minOfScores);
    }
  }
}
