import CSLib.*;

public class StockProfit {
  // Determine best buy-sell period
  // Author: Max Kamin, June 24, 1997

  int profit = 0; // best profit possible so far
  
  public void compute () {
  
    int minPrice,   // lowest price so far
        priceToday; // last price input

    InputBox in = new InputBox("Stock Market Problem"); 
    // Determine initial minimum price
    in.setPrompt("Enter value of stock: ");
    priceToday = in.readInt();
    minPrice = priceToday;
  
    do { 
      // minPrice = minimum price seen before today.
      // profit = maximum profit possible, if buy
      //   and sell dates are before today.

      // What is the next day's price?
      in.setPrompt("Enter value of stock: ");
      priceToday = in.readInt();
      if (in.eoi()) return;

      // Is today a new minimum price?
      if (priceToday < minPrice)
        minPrice = priceToday;
      // Does a sell today maximize profit?
      if (priceToday - minPrice > profit)
        profit = priceToday - minPrice;
    } while (true);
  }
  
  public void print () {
    OutputBox out = new OutputBox("Stock Market Problem");
    out.println("Maximum profit = " + profit + " dollars.");
  }
}
