import CSLib.*;

public class StockProfit {
  // Determine best buy-sell period
  // Author: Max Kamin, June 24, 1997

  int profit = 0,      // best profit possible so far
      buyDay = 0,      // best day to buy
      sellDay = 0;     // best day to sell
  
  public void compute () {
    int minPrice = 9999999,   // lowest price so far
        priceToday,           // last price input
        today = 1,            // current day
        minDay = 1;           // day of minPrice
  
    InputBox in = new InputBox("Stock Market Problem"); 
  
    while (true) {
      // minPrice = minimum price seen before today.
      // profit = maximum profit possible, if buy
      //   and sell dates are before today.
      // today = number of days read.
      // minDay is the day on which minPrice was achieved.
      // buyDay and sellDay are the best days to buy
      //   and sell before today
      
      // What is the next day's price?
      in.setPrompt("Enter value of stock on day " + today + ": ");
      priceToday = in.readInt();
      today++;
      if (in.eoi()) break;
  
      // Is today a new minimum price?
      if (priceToday < minPrice) {
        minPrice = priceToday;
        minDay = today;
      }
      // else does a sell today maximize profit?
      else if (priceToday - minPrice > profit) {
        profit = priceToday - minPrice;
        buyDay = minDay;
        sellDay = today;
      }
    }
  }
  
  public void print () {
    OutputBox out = new OutputBox("Stock Market Problem");
    out.println("Maximum profit from buying on day "
      + buyDay + " and selling on day " + sellDay + ".");
  }
}
