import CSLib.*;

public class Sweep {
  // Maintain a Clock that can advance by sweeping.
  // Author: Courtney Mickunas, November 21, 2000

  Clock c;                // Our own clock to manipulate.
  DrawingBox d;           // ... in its own DrawingBox
  final static int SIZE = 250;

  public void setup () {
    c = new Clock();
    d = new DrawingBox("Ticking Clock");
    d.setDrawableSize(SIZE, SIZE); 
    c.display(d, SIZE/2, SIZE/2, SIZE/2);
  }

  public void sweep () {
    int advance = 0;      // How many minutes to advance.
    InputBox in = new InputBox();

    // Loop repeatedly, drawing the clock and reading input.
    do {
      // minute+advance is the desired final time
      for (int i=1; i<=advance; i++) {
        // Advance the time.
        c.setMinute(c.getMinute()+1);

        // Update the clock display.
        d.clear();
        c.display(d, SIZE/2, SIZE/2, SIZE/2);
      }

      in.setPrompt("Advance how many minutes?");
      advance = in.readInt();
    } while (!in.eoi());
  }
}
