import CSLib.*;

class ReadAndAvg {

  public ReadAndAvg () {
    final int INPUT_MAX = 100;
    GradeBook grades = new GradeBook(INPUT_MAX);
    grades.readAndAverage();
  }
  
  public static void main (String[] arg) {
    new ReadAndAvg();
  }
}

public class GradeBook {
  // A grade book of student grades.
  // Author: D. Benjamin Gordon, August 25, 2000

  Student[] students;
  int size = 0;
  
  public GradeBook (int number) {
    students = new Student[number];
  }
  
  public void readAndAverage () {
    InputBox in = new InputBox();

    // Read names and exam grades; size counts inputs
    String nextname;
    while (true) {
       in.setPrompt("Enter a name (null to terminate):");
      nextname = in.readString();
      if (nextname.length() == 0) break;
      students[size] = new Student();
      students[size].setName(nextname);
      in.setPrompt("Enter first exam grade: ");
      students[size].setExam1(in.readInt());
      in.setPrompt("Enter second exam grade: ");
      students[size].setExam2(in.readInt());
      size++;
    }
  
    OutputBox out = new OutputBox();
    out.println();
    out.println("\tName             \tAverage");
    for (int i=0; i<size; i++) {
      out.println("\t" + students[i].getName() + "\t\t\t" + students[i].getAvg());
    }
  }
}

class Student {
  private String name;
  private int exam1, exam2;

  public Student () {}
  public void setName (String s) { name = s; }
  public void setExam1 (int s) { exam1 = s; }
  public void setExam2 (int s) { exam2 = s; }
  public String getName () { return name; }
  public int getExam1 () { return exam1; }
  public int getExam2 () { return exam2; }
  public int getAvg () { return (exam1+exam2)/2; }
}

