class GradeDistribution {
  // Keep track of a grade distribution.
  // Author: Rachel N. Reingold, January 31, 2001

  // counts stores the count for each group.  That is,
  //  counts[0] is the number of grades between 0 and 9,
  //  counts[1] is the number of grades between 10 and 19, etc.
  private int[] counts;

  public GradeDistribution () {
    counts = new int[10];
  }

  // Report new grade to be added to distribution
  public void insertGrade (int g) {
    // Ignore grades that are out of range
    if (g < 0 || g > 100) return;
    int group = g / 10;
    if (group == 10) // i.e. grade = 100
      group = 9;
    counts[group]++;
  }

  // Return count for given group
  public int groupCount (int gp) {
    if (gp < 0 || gp > 10) return 0;
    return counts[gp];
  }

}
