import CSLib.*;

public class GradeReport {
  // Build and use a GradeDistribution
  // Author: Robert D. Klapper, November 16, 2000

  public void readScores (GradeDistribution distr) {
    InputBox in = new InputBox("Enter grade: ");
    while (true) {
      int g = in.readInt();
      if (in.eoi()) return;
      distr.insertGrade(g);
    }
  }

  public void barGraph (GradeDistribution distr) {
    // With screen width w and height h, place bar
    // for i(th) group at i*w/10 pixels from left, with
    // width w/10 and height h/20 times the count
    DrawingBox out = new DrawingBox("Grade Histogram");
    int w = out.getWidth(),
        h = out.getHeight();
    int barwidth = w/10;
    for (int i=0; i<10; i++) {
      int horizpos = i*barwidth,
          height = distr.groupCount(i)*h/20;
      out.drawRect(horizpos, 0, barwidth, height);
    }
  }

}
