import CSLib.*;

public class GradeReport {
  // Build and use a GradeDistribution
  // Author: Robert D. Klapper, November 16, 2000

  public void readScores (GradeDistribution distr) {
    InputBox in = new InputBox("Enter grade: ");
    while (true) {
      int g = in.readInt();
      if (in.eoi()) return;
      distr.insertGrade(g);
    }
  }

  public void barGraph (GradeDistribution distr) {
    // With n groups and maximum count of m, and
    // screen width w and height h, place bar for
    // i(th) group at i*w/n pixels from left, with
    // width w/n and height h/m times the count
    DrawingBox out = new DrawingBox("Grade Histogram");
    int m = distr.maxCount(),
        n = distr.numGroups(),
        w = out.getDrawableWidth(),
        h = out.getDrawableHeight();
    int barwidth = w/n;
    for (int i=0; i<n; i++) {
      int horizpos = i*barwidth,
          height = distr.groupCount(i)*h/m;
      out.drawRect(horizpos, h-height, barwidth, height);
    }
  }
}
