import CSLib.*;
import java.awt.*;
import java.awt.event.*;

public class MazeDrawer {
  // Draw a given maze in a given DrawingBox
  // Author: Stephanie Ries, October 9, 2000

  final int NORTH=0, EAST=1, SOUTH=2, WEST=3;

  Maze theMaze;
  DrawingBox d;
  Dimension mazeSize;
  int cellW, cellH;

  public MazeDrawer (Maze theMaze, DrawingBox d) {

    this.theMaze = theMaze;
    this.d = d;

    // Determine the size of a wall segment 
    mazeSize = theMaze.getSize();
    cellW = d.getWidth() / (mazeSize.width + 2);
    cellH = d.getHeight() / (mazeSize.height + 2);
  }

  public int getCellW () {return cellW;}

  public int getCellH () {return cellH;}

  public void draw () {
    d.clear();
    // Draw the maze
    for (int row = 1; row <= mazeSize.height + 1; row++) 
        for (int col = 1; col <= mazeSize.width; col++)
            if (theMaze.checkWall(NORTH, col, row))
                d.drawLine( col*cellW, row*cellH, 
                            (col+1)*cellW, row*cellH);
    for (int row = 1; row <= mazeSize.height; row++)
        for (int col = 1; col <= mazeSize.width+1; col++)
            if (theMaze.checkWall(WEST, col, row))
                d.drawLine( col*cellW, row*cellH,
                            col*cellW, (row+1)*cellH);
  }

}
