import CSLib.*;
import java.awt.*;
import java.awt.event.*;

public class MouseMaze implements MouseListener {
  // Make a mouse move through a maze.
  // Author: Stephanie Ries, October 9, 2000

  final int NORTH=0, EAST=1, SOUTH=2, WEST=3;

  Maze theMaze;
  Dimension mazeSize;
  int cellW, cellH;
  Mouse speedy;
  Image[] mousegif = new Image[4];
  DrawingBox d;

  public MouseMaze() {

    // Create a DrawingBox, a Maze and a Mouse
    d = new DrawingBox();
    theMaze = new Maze();
    speedy = new Mouse(theMaze);

    // Determine the size of a wall segment 
    mazeSize = theMaze.getSize();
    cellW = d.getWidth() / (mazeSize.width + 2);
    cellH = d.getHeight() / (mazeSize.height + 2);

    drawMaze();

    // Get the four rodent images.
    for (int i=0; i<4; i++) {
      mousegif[i] = Toolkit.getDefaultToolkit().getImage("images/mouse"+i+".gif");
    }

    // Draw speedy at his initial location. 
     drawMouse();
 
    // Wait for mouse clicks.
    d.addMouseListener(this); 
  }

  private void drawMouse() {
    // Draw the mouse
    Point p = speedy.tellLocation();
    int direction = speedy.tellDirection();
    d.drawImage(mousegif[direction], p.x*cellW+cellW/3, p.y*cellH+cellH/3);
  }

  private void drawMaze() {
    d.clear();
    // Draw the maze
    for (int row = 1; row <= mazeSize.height + 1; row++) 
        for (int col = 1; col <= mazeSize.width; col++)
            if (theMaze.checkWall(NORTH, col, row))
                d.drawLine( col*cellW, row*cellH, 
                            (col+1)*cellW, row*cellH);
    for (int row = 1; row <= mazeSize.height; row++)
        for (int col = 1; col <= mazeSize.width+1; col++)
            if (theMaze.checkWall(WEST, col, row))
                d.drawLine( col*cellW, row*cellH,
                            col*cellW, (row+1)*cellH);
  }

  public void mouseClicked(MouseEvent e) {
    // Cause speedy to make a move.
    speedy.makeMove();
    drawMaze();
    drawMouse();
  }

  public void mouseEntered(MouseEvent e){}
  public void mouseExited(MouseEvent e){}
  public void mousePressed(MouseEvent e){}
  public void mouseReleased(MouseEvent e){}

  public static void main (String[] args) {
    new MouseMaze();
  }
}
