import CSLib.*;

class Collection {
    private int[] item;
    private int size = 0;
    private int[] copy;
  
  public Collection (int number) {
    item = new int[number];
  }
  
  int readArray (int[] A) {
    InputBox in = new InputBox();
    in.setPrompt("How many items? ");
    int size = in.readInt();
    for (int i = 0; i < size; i++) {
      in = new InputBox();
      in.setPrompt("Enter next number: ");
      A[i] = in.readInt();
    };
    return size;
  }
  
  void printArray (int[] A, int size, OutputBox out) {
    for (int i = 0; i < size; i++)
      out.println(A[i]);
  }
  
  public void read() {
    size = readArray(item);  
  }
  
  public void print(OutputBox o) {
    printArray(item, size, o);
  }
  
  public void sort() {
    copy = new int[size];
    for (int i = 0; i < size; i++) 
      copy[i] = item[i];
    insertionSort (copy);
  }
  
  public void printSorted(OutputBox o) {
    printArray(copy, copy.length, o);
  }
  
  static void insertionSort (int[] A) {
    int i, j;
    for (i=1; i<A.length; i++) {
      // Elements in A[0]..A[i-1] are sorted.
      // Insert A[i] into correct position in A[0]..A[i]
      int Ai = A[i];
      j = i-1;
      while (j>=0 && A[j]>Ai) {
        // A[0]..A[i] sorted, but if j<i-1, A[j+1]
        // is a "gap"
        A[j+1] = A[j];
        j--;
      }
      // Note: Ai goes into A[j+1] even if j=-1
      A[j+1] = Ai;
    }
  }
  
  // Locate key in an array of ints
  int linearSearch (int[] A, int key) {
    int i;
    for (i=0; i<A.length; i++)
      // key not in A[0]..A[i-1]
      if (A[i] == key) return i;
    // key not in A
    return -1;
  }
  
  public int find(int key){
    return linearSearch(item, key);
  }
}

public class Search {
    
  public Search() {
    final int MAX = 1000; 
    Collection c = new Collection(MAX);
    c.read();
    OutputBox out = new OutputBox();
    out.println("Original List:");
    c.print(out);
    c.sort();
    InputBox in = new InputBox();
    in.setPrompt("Find what?");
    int key = in.readInt();
    
    out.println(key+" is at "+c.find(key)+" in the original list");
  }
  
  public static void main (String[] args) {
    new Search();
  }
}
