public class SelectionSort {
  // Sort an array of doubles
  // Author: M. Dennis Mickunas, June 9, 2001
  
  public void selectionSort (double[] A, int size) {
    int i, j;
    for (i=0; i<size; i++) {
      // All elements in A[0]..A[i-1] are less than
      // all elements in A[i]..A[size-1], and
      // a[0]..A[i-1] is sorted.
      int min = findMinimum(A, i, size);
      swap(A, i, min);
    }
  }
  
  // Locate the smallest value in an array.
  int findMinimum (double[] A, int i, int size) {
    int j, min = i;
    for (j=i+1; j<size; j++)
      // A[min] <= all elements in A[i]..A[j-1]
      if (A[j] < A[min]) min = j;
    return min;
  }
  
  // Exchange A[i] and A[j]
  void swap (double[] A, int i, int j) {
    double temp = A[i];
    A[i] = A[j];
    A[j] = temp;
  }
}

