import CSLib.*;
import java.awt.*;

public class Crossword {
  // Draw a 9x9 crossword puzzle
  // Sherwin Kamin, Feb. 5, 2001

  final static int BOARD_HEIGHT = 9,
                   BOARD_WIDTH = 9;

  private char[][] theBoard =
    {{' ', ' ', ' ', ' ', '#', ' ', ' ', ' ', ' '},
     {' ', '#', ' ', '#', ' ', '#', ' ', '#', ' '},
     {' ', ' ', ' ', ' ', ' ', '#', ' ', ' ', ' '},
     {' ', '#', '#', '#', ' ', '#', ' ', '#', ' '},
     {'#', ' ', ' ', ' ', ' ', ' ', ' ', ' ', '#'},
     {' ', '#',' ', '#', ' ', '#', '#', '#', ' '},
     {' ', ' ', ' ', '#', ' ', ' ', ' ', ' ', ' '},
     {' ', '#', ' ', '#', ' ', '#', ' ', '#', ' '},
     {' ', ' ', ' ', ' ', '#', ' ', ' ', ' ', ' '}
    };

  public void display (DrawingBox b) {
    b.setDrawableSize(300,300);
    int sq_height = 300/BOARD_HEIGHT,
        sq_width = 300/BOARD_WIDTH;

    for (int r=0; r<BOARD_HEIGHT; r++)
      for (int c=0; c<BOARD_WIDTH; c++) {
        if (theBoard[r][c] == '#')
          b.fillRectangle(c*sq_width, r*sq_height,
                          sq_width, sq_height);
        else {
          b.drawRectangle(c*sq_width, r*sq_height,
                          sq_width, sq_height);
          if (theBoard[r][c] != ' ')
            b.drawString(theBoard[r][c]+"",
                          (int)((c+0.45)*sq_width),
                          (int)((r+0.7)*sq_height));
        }
      }
    }

}

