import CSLib.*;
import java.awt.*;

public class Crossword {

  final static int BOARD_HEIGHT = 9,
                   BOARD_WIDTH = 9;

  char[][] theBoard =
    {{' ', ' ', ' ', ' ', '#', ' ', ' ', ' ', ' '},
     {' ', '#', ' ', '#', ' ', '#', ' ', '#', ' '},
     {' ', ' ', ' ', ' ', ' ', '#', ' ', ' ', ' '},
     {' ', '#', '#', '#', ' ', '#', ' ', '#', ' '},
     {'#', ' ', ' ', ' ', ' ', ' ', ' ', ' ', '#'},
     {' ', '#',' ', '#', ' ', '#', '#', '#', ' '},
     {' ', ' ', ' ', '#', ' ', ' ', ' ', ' ', ' '},
     {' ', '#', ' ', '#', ' ', '#', ' ', '#', ' '},
     {' ', ' ', ' ', ' ', '#', ' ', ' ', ' ', ' '}
    };

  int[][] theNumbers =
    {{ 1, 0,  2, 0,  0,  3,  4, 0,  5},
     { 0, 0,  0, 0,  6,  0,  0, 0,  0},
     { 7, 0,  0, 0,  0,  0,  8, 0,  0},
     { 0, 0,  0, 0,  0,  0,  0, 0,  0},
     { 0, 9, 10, 0,  0,  0,  0, 0,  0},
     {11, 0,  0, 0,  0,  0,  0, 0, 12},
     {13, 0,  0, 0, 14,  0, 15, 0,  0},
     { 0, 0,  0, 0,  0,  0,  0, 0,  0},
     {16, 0,  0, 0,  0, 17,  0, 0,  0}};

  public void display (DrawingBox b) {
    b.setDrawableSize(300,300);
    int sq_height = 300/BOARD_HEIGHT,
        sq_width = 300/BOARD_WIDTH;

    for (int i=0; i<BOARD_HEIGHT; i++)
      for (int j=0; j<BOARD_WIDTH; j++) {
        if (theBoard[i][j] == '#')
          b.fillRectangle(j*sq_width, i*sq_height,
                          sq_width, sq_height);
        else {
          b.drawRectangle(j*sq_width, i*sq_height,
                          sq_width, sq_height);
          if (theBoard[i][j] != ' ')
            b.drawString(theBoard[i][j]+"",
                          (int)((j+0.45)*sq_width),
                          (int)((i+0.7)*sq_height));
          if (theNumbers[i][j] != 0)
            b.drawString(theNumbers[i][j]+"",
                          (int)((j+0.1)*sq_width),
                          (int)((i+0.4)*sq_height));
        }
      }
    }

}



