import CSLib.*;
import java.awt.*;

public class Draw {
  // Draw the contents of a SoftFrame
  // Author: Elizabeth Baranowicz, September 8, 1996
  
  final static int WIDTH = 90,
                   HEIGHT = 60;
  static SoftFrame scr = new SoftFrame(WIDTH, HEIGHT);

  void drawShapes () {

    // Draw grid lines.
    scr.clearSoftFrame();
    for (int r = 10; r < HEIGHT; r = r + 10)
      scr.drawHorizontalLine(r);
    for (int c = 10; c < WIDTH; c = c + 10)
      scr.drawVerticalLine(c);
    scr.displaySoftFrame("Grid");

    // Draw long lines badly
    scr.clearSoftFrame();
    scr.drawLongLine(.3,2);
    scr.drawLongLine(1,5);
    scr.drawLongLine(3,10);
    scr.displaySoftFrame("Bad Long Lines");

    // Draw all lines correctly
    scr.clearSoftFrame();
    scr.drawLine1(new Point(45,0), new Point(45,59));
    scr.drawLine1(new Point(0,30), new Point(89,30));
    scr.drawLine1(new Point(10,0), new Point(70,14));
    scr.drawLine1(new Point(50,20), new Point(55,50));
    scr.displaySoftFrame("All Good Lines");

    // Draw all lines correctly
    scr.clearSoftFrame();
    Point start = new Point(0,0);
    for (int i = 1; i < 6; i++) 
      scr.drawLine(start, new Point(WIDTH, i*HEIGHT/5));
    scr.displaySoftFrame("All Fast Lines");

    // Draw circles badly
    scr.clearSoftFrame();
    Point center = new Point(WIDTH/2, HEIGHT/2);
    for (int r = 5; r < HEIGHT/2; r = r + 10) 
      scr.drawCircle1(center, r);
    scr.displaySoftFrame("Bad Circles");

    // Draw circles correctly
    scr.clearSoftFrame();
    center = new Point(WIDTH/2, HEIGHT/2);
    for (int r = 5; r < HEIGHT/2; r = r + 10) 
      scr.drawCircle(center, r);
    scr.displaySoftFrame("Good Circles");
  }
}
