import java.awt.*;

class Maze {
  // Representation of a maze object
  // Author: Jamie Ries, October 5, 2000

  final int NORTH=0, EAST=1, SOUTH=2, WEST=3;

  // record the walls to the east
  private boolean[][] eWall = 
      {{false ,false,false,false,false },
       {true ,false,false,false,true },
       {false,true ,true ,false,true },
       {true ,true ,false,true ,true }};
  // record the walls to the south
  private boolean[][] sWall = 
      {{false,true ,true ,true ,false},
       {false,false,false,false,true },
       {false,false,false,false,false},
       {false,true ,true ,true ,true }};
  private int height = 3, width = 4;
  private Point size = new Point(width, height);
  
  // Where is the starting location?
  public Point getStartLocation () {return new Point(0,2);}

  // In which direction do you face to enter?
  public int getStartDirection () {return EAST;}

  public Point getSize() {return size;}
  
  // Is a given position outside the maze?
  public boolean outside (Point pos) {
    return ((pos.x < 1) 
         || (pos.x > width) 
         || (pos.y < 1) 
         || (pos.y > height)
       );
  }

  // Is there a wall to the 'dir' direction 
  // of location (row,col)?
  public boolean checkWall (int dir, int row, int col) {
    switch (dir) {
      case NORTH: return sWall[row-1][col];
      case SOUTH: return sWall[row][col];
      case EAST:  return eWall[row][col];
      default:    return eWall[row][col-1];
    }
  }
  
  // Alternative version of checkWall
  public boolean checkWall (int dir, Point location) {
    return checkWall(dir, location.y, location.x);
  }
}
