import CSLib.*;

public class USenergy {
  // Print a table of energy usage
  // Author: Frieda F. Foster, May 23, 1996
  
  final int 
    NUM_SOURCES = 6,
    NUM_YEARS = 5;
  
  double[][] 
    energyTable = new double[NUM_YEARS][NUM_SOURCES];

  double[] yearTotals = new double[NUM_YEARS];
  double[] sourceTotals = new double[NUM_SOURCES];
  double totalEnergy = 0.0;
  
  final int 
    FIRST_YEAR = 1989;
  
  public void readData () {
    InputBox in = new InputBox();

    int y, s;
    for (y = 0; y < NUM_YEARS; y++)
      for (s = 0; s < NUM_SOURCES; s++)
        energyTable[y][s] = in.readDouble();
  }
  
  public void computeTotals () {
    // Compute total energy use for each year
    int y, s;
  
    for (y = 0; y < NUM_YEARS; y++) {
      // Compute total for year y
      yearTotals[y] = 0.0;
      for (s = 0; s < NUM_SOURCES; s++)
        yearTotals[y] = 
          yearTotals[y] + energyTable[y][s];
      }
  
    // Compute total use of each source
  
    for (s = 0; s < NUM_SOURCES; s++) {
      // Compute total for source s
      sourceTotals[s] = 0.0;
      for (y = 0; y < NUM_YEARS; y++)
        sourceTotals[s] = 
          sourceTotals[s] + energyTable[y][s];
      }
  
    // Compute total energy use
    for (y = 0; y < NUM_YEARS; y++)
      totalEnergy = totalEnergy + yearTotals[y];
  }   

  public void printTable () {
    OutputBox out = new OutputBox();
    int y, s;

    out.println("       "
         + "  Coal"
         + "    Gas"
         + "    Oil"
         + "  Hydro"
         + "  Nuclear"
         + " Other"
         + "  Total");
  
    for (y = 0; y < NUM_YEARS; y++) {
      out.print(SFormat.sprintr(6, FIRST_YEAR+y));
      for (s = 0; s < NUM_SOURCES; s++)
        out.print(SFormat.sprintr(7, 1, energyTable[y][s]));
      out.print(SFormat.sprintr(7, 1, yearTotals[y]));
      out.println();
    }
    out.print(SFormat.sprintr(6, "Total"));
    for (s = 0; s < NUM_SOURCES; s++)
      out.print(SFormat.sprintr(7, 1, sourceTotals[s]));
    out.print(SFormat.sprintr(7, 1, totalEnergy));
    out.println();
  } 
}
