import CSLib.*;

public class USenergy {
  // Print a table of energy usage
  // Author: Frieda F. Foster, May 23, 1996
  
  final int 
    NUM_SOURCES = 6,
    NUM_YEARS = 5;
  
  double[][] energyTable = 
    {
      {18.9, 19.4, 34.2, 2.9, 5.7, 0.3},
      {19.1, 19.3, 33.6, 3.0, 6.2, 0.2},
      {18.8, 19.6, 32.9, 3.1, 6.6, 0.2},
      {18.9, 20.3, 33.5, 2.8, 6.7, 0.2},
      {19.6, 20.8, 33.8, 3.1, 6.5, 0.2}
    };
  
  final int 
    FIRST_YEAR = 1989;
  
  public void buildTable () {

    int y, s;
  
    // Compute total energy use for each year
    double[] yearTotals = new double[NUM_YEARS];
  
    for (y = 0; y < NUM_YEARS; y++) {
      yearTotals[y] = 0.0;
      // Compute total for year y
      for (s = 0; s < NUM_SOURCES; s++)
        yearTotals[y] = 
          yearTotals[y] + energyTable[y][s];
      }
  
    // Compute total use of each source
    double[] sourceTotals = new double[NUM_SOURCES];
  
    for (s = 0; s < NUM_SOURCES; s++) {
      sourceTotals[s] = 0.0; 
      // Compute total for source s
      for (y = 0; y < NUM_YEARS; y++)
        sourceTotals[s] = 
          sourceTotals[s] + energyTable[y][s];
      }
  
    // Compute total energy use
    double totalEnergy = 0.0;
    for (y = 0; y < NUM_YEARS; y++)
      totalEnergy = totalEnergy + yearTotals[y];
    
    OutputBox out = new OutputBox();

    out.println("       "
         + "  Coal"
         + "    Gas"
         + "    Oil"
         + "  Hydro"
         + "  Nuclear"
         + " Other"
         + "  Total");
  
    for (y = 0; y < NUM_YEARS; y++) {
      out.print(SFormat.sprintr(6, FIRST_YEAR+y));
      for (s = 0; s < NUM_SOURCES; s++)
        out.print(SFormat.sprintDecimal(7, 1, energyTable[y][s]));
      out.print(SFormat.sprintDecimal(7, 1, yearTotals[y]));
      out.println();
    }
    out.print(SFormat.sprintr(6, "Total"));
    for (s = 0; s < NUM_SOURCES; s++)
      out.print(SFormat.sprintDecimal(7, 1, sourceTotals[s]));
    out.print(SFormat.sprintDecimal(7, 1, totalEnergy));
    out.println();
  } 
}
