import CSLib.*;

public class MouseMazeController {
  // Draw a mouse navigating a maze, using a choice of algorithms.
  // Rebecca Kamin, Sept 12, 2000

  public void runMouse () {
    DrawingBox d = new DrawingBox("Mouse in maze");
    Maze theMaze = new Maze();
    MazeDrawer theMazeDrawer = new MazeDrawer(theMaze, d);
    Mouse speedy;

    InputBox in = new InputBox();
    in.setPrompt("Type 1 for a left-mover, otherwise you get a right-mover");
    if (in.readInt() == 1)
      speedy = new Mouse(theMaze, new LeftMover());
    else
      speedy = new Mouse(theMaze, new RightMover());

    MouseDrawer speedyDrawer =
                   new MouseDrawer(speedy, theMazeDrawer, d);

    while (true) {
      theMazeDrawer.draw();
      speedyDrawer.draw();
      Timer.pause(1000);
      speedy.makeMove();
    }
  }
}
