public class SFormat {

  // A class for formatting integers, strings, and decimals.
  // Author Marie Mickunas, August 2, 2001

  private static String s;  
  private static String BLANKS=
   "                                                                      ";

  public static String sprintr (int w, int i) {
  // Stringify an integer right-justified 
  // in a field of width w
    if (w<=0) return "";
    s=BLANKS+i;
    return s.substring( Math.min(0, s.length()-w) );
  }

  public static String sprintr (int w, String str) {
  // Right-justify a String in a field of width w
    if (w<=0) return "";
    s=BLANKS+str;
    return s.substring( Math.min(0, s.length()-w) );
  }

  public static String sprintr (int w, double d) {
  // Stringify a double right-justified
  // in a field of width w
    if (w<=0) return "";
    s=BLANKS+d;
    return s.substring( Math.min(0, s.length()-w) );
  }

  public static String sprintr (int w, int r, double d) {
  // Stringify a decimal with r decimal places to the right of 
  // the point in a field of width w.
    return sprintr(w-r-1, (int)d) + "." 
      + sprintzr(r, (int)Math.round(Math.pow(10.0, r)*(d-Math.floor(d))));
  } 

  private static String ZEROS = 
    "000000000000000000000000000000000000000000000000000000";

  public static String sprintzr (int w, int i) {
    String s=ZEROS+i;
    return s.substring(s.length()-w);
  }
}
