import CSLib.*;
import java.awt.*;
import java.awt.event.*;

public class ClickableClock implements MouseListener {
  // Maintain a clock.
  // Author: Courtney Mickunas, November 21, 2000
  
  private DrawingBox d;
  private Clock myClock;
  private final int WIDTH = 300,
                    HEIGHT = 320,
                    RADIUS = Math.min(WIDTH, HEIGHT)/2,
                    INCREMENT = 5;

  public ClickableClock () {
    this(12, 0);
  }

  public ClickableClock (int hour, int minute) {
    d = new DrawingBox("ClickableClock Window");
    d.setDrawableSize(WIDTH, HEIGHT);
    myClock = new Clock(d, hour, minute);
    myClock.display(RADIUS);
    d.addMouseListener(this);
  }

  public void mouseClicked (MouseEvent e) {
    setMinute(getMinute()+INCREMENT);
    d.clear();
    myClock.display(RADIUS);
   }

  public void mousePressed (MouseEvent e) { }
  public void mouseReleased (MouseEvent e) { }
  public void mouseEntered (MouseEvent e) { }
  public void mouseExited (MouseEvent e) { } 

  public void getData () { myClock.getData(); }
  public String toString() { return myClock.toString(); }
  public void setHour (int h) { myClock.setHour(h); }
  public void setMinute (int m) { myClock.setMinute(m); }
  public void set (int hour, int minute) { myClock.set(hour, minute); }
  public int getHour () { return myClock.getHour(); }
  public int getMinute () { return myClock.getMinute(); }
  public boolean priorTo (Clock c) { return myClock.priorTo(c); }
  public boolean after (Clock c) { return c.priorTo(myClock); }
}
