import CSLib.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class Eyes {

  // Animated eyes that follow the cursor.  
  // Author: Caitlin Little, December 27, 1996

  private Point left, right, leftPupil, rightPupil;
  public static final int 
    EYE_RADIUS = 30,
    PUPIL_RADIUS = 10;
  
  // create a pair of eyes, centered at Point c
  public Eyes (Point c) {
    // Determine center of each eyeball
    left = new Point(c.x-EYE_RADIUS-1, c.y); 
    right = new Point(c.x+EYE_RADIUS+1, c.y);
  }
  
  public void gaze (DrawingBox d, Point cursor) {
  
    // Draw the pink eyes
    d.setColor(Color.pink);
    fillCircle(d, left, EYE_RADIUS);
    fillCircle(d, right, EYE_RADIUS);
  
    // Draw the pupils
    d.setColor(Color.black);
    leftPupil = compute(cursor, left);
    fillCircle(d, leftPupil, PUPIL_RADIUS);
    rightPupil = compute(cursor, right);
    fillCircle(d, rightPupil, PUPIL_RADIUS);
  }

  private void fillCircle (DrawingBox d, Point p, int radius) {
    d.fillOval(p.x-radius, p.y-radius, 2*radius, 2*radius);
  }
  
  private Point compute (Point cursor, Point eye) {
  // Compute the location of the pupil, given the
  // locations of the eye and the cursor.
    double d = Math.sqrt((cursor.x-eye.x)*(cursor.x-eye.x)
                       + (cursor.y-eye.y)*(cursor.y-eye.y));
    int r = EYE_RADIUS - PUPIL_RADIUS;
    return new Point(eye.x + (int)((cursor.x-eye.x)*r/d),
                     eye.y + (int)((cursor.y-eye.y)*r/d));
  }
}
