import CSLib.*;
import java.awt.*;
import java.awt.event.*;

public class TwoEyes implements MouseMotionListener {

  // Animated eyes that follow the cursor.  
  // Author: Caitlin Little, December 27, 1996

  private final int WIDTH = 700,
                    HEIGHT = 600;
  private Point cursor = new Point(WIDTH/2, HEIGHT/2);
  private Eyes e1, e2; 
  private DrawingBox d;

  public TwoEyes () {
    d = new DrawingBox();
    // Register the Listener.
    d.addMouseMotionListener(this);
    d.setDrawableSize(WIDTH, HEIGHT);
    e1 = new Eyes(new Point(Eyes.EYE_RADIUS*2+2, 
                            Eyes.EYE_RADIUS+2)); // center of one set of eyes 
    e2 = new Eyes(new Point(WIDTH-Eyes.EYE_RADIUS*2-2,
                            Eyes.EYE_RADIUS+2)); // center of the other set
    e1.gaze(d, cursor);
    e2.gaze(d, cursor);
  }
 
  public void mouseMoved (MouseEvent e) {
    cursor = e.getPoint(); 
    e1.gaze(d, cursor);
    e2.gaze(d, cursor);
  }
  
  public void mouseDragged (MouseEvent e) {}
}
