public class Operation {

  // Objects represent the operands and operator of an
  //  arithmetic expression.
  // Rachel Reingold,  Jan. 31, 2000

  private int opnd1, opnd2;
  private char optr; // must be +, -, /, or *

  private Operation (int opnd1, int opnd2, char optr) {
    this.opnd1 = opnd1;
    this.opnd2 = opnd2;
    this.optr = optr;
  }

  static Operation parse (String s) {
    // s should have form "integer op integer"
    // Divide into three parts and return Operation object

    int i = getInteger(s, 0);
    int opnd1 = Integer.parseInt(inputfrag);

    char optr = s.charAt(i);

    i = getInteger(s, i+1);
    int opnd2 = Integer.parseInt(inputfrag);

    return new Operation(opnd1, opnd2, optr);
  }

  private static String inputfrag;

  private static int getInteger (String s, int loc) {
    int endloc = loc;
    do { endloc++; }
    while (endloc < s.length() && isDigit(s.charAt(endloc))) ;
    inputfrag = s.substring(loc, endloc);
    return endloc;
  }

  private static boolean isDigit (char c) {
    return ('0' <= c && c <= '9');
  }

  int calculate () {
    switch (optr) {
      case '+': return opnd1+opnd2;
      case '-': return opnd1-opnd2;
      case '/': return opnd1/opnd2;
      case '*': return opnd1*opnd2;
    }
    return 0;  // shouldn't happen!
  }
}
