
public class Clock {
  // Maintain a simple clock.
  // Author: Courtney Mickunas, November 21, 2000
  
  protected int hour, minute;

  public Clock () {
    hour = 12;  minute = 0;
  }

  public Clock (int h, int m) {
    hour = h;  minute = m;
  }

  // Convert clock to printable format
  public String toString () {
     String result = hour + ":";
     if (minute < 10) result = result + "0";
     return (result + minute);
  }

  public void advanceMinutes (int m) {
    int totalMinutes = (hour * 60 + m) % (12 * 60);
    // totalMinutes is between -(12 * 60) and (12 * 60)
    if (totalMinutes < 0) totalMinutes = totalMinutes + (12 * 60);
    hour = totalMinutes / 60;
    if (hour == 0) hour = 12;
    minute = totalMinutes % 60;
  }
}
