import CSLib.*;
import java.awt.*;
import java.awt.event.*;

public class MazeDrawer implements Direction {
  // Draw a given maze in a given DrawingBox
  // Author: Stephanie Ries, October 9, 2000

  Maze theMaze;
  DrawingBox d;
  Point mazeSize;
  int cellW, cellH;

  public MazeDrawer (Maze theMaze, DrawingBox d) {

    this.theMaze = theMaze;
    this.d = d;

    // Determine the size of a wall segment 
    mazeSize = theMaze.getSize();
    cellW = d.getWidth() / (mazeSize.x + 2);
    cellH = d.getHeight() / (mazeSize.y + 2);
  }

  public int getCellW () {return cellW;}

  public int getCellH () {return cellH;}

  public void draw () {
    d.clear();
    // Draw the maze
    for (int row = 1; row <= mazeSize.y + 1; row++) 
        for (int col = 1; col <= mazeSize.x; col++)
            if (theMaze.checkWall(NORTH, row, col))
                d.drawLine( col*cellW, row*cellH, 
                            (col+1)*cellW, row*cellH);
    for (int row = 1; row <= mazeSize.y; row++)
        for (int col = 1; col <= mazeSize.x+1; col++)
            if (theMaze.checkWall(WEST, row, col))
                d.drawLine( col*cellW, row*cellH,
                            col*cellW, (row+1)*cellH);
  }

}
