import java.awt.Point;

class Mouse implements Direction {
  // A mouse that can navigate a maze
  // Author: Allan M. Mickunas, September 22, 1996
  
  protected Maze theMaze;
  protected boolean started = false; // true once the maze 
                                   // is entered.
  protected Point location; // The location of this Mouse
  protected int direction;  // The direction this Mouse is facing
  
  public Point tellLocation () {return location;}

  public int tellDirection () {return direction;}
  
  public Mouse (Maze m) {
    theMaze = m;
    // Where do I start?
    location = m.getStartLocation();
    // In what direction do I face initially?
    direction = m.getStartDirection(); 
  }

  protected boolean outside () {
  // Am I outside the maze?
    return theMaze.outside(location);
  }
  
  protected boolean facingWall () {
    return theMaze.checkWall(direction, location);
  }
  
  protected void stepForward () {
    switch (direction) {
      case NORTH: location.y--; break;
      case EAST:  location.x++; break;
      case SOUTH: location.y++; break;
      case WEST:  location.x--; break;
    }
  }
  
  protected void turnLeft() {
    direction = (direction+3) % 4;
  }
  
  protected void turnRight() {
    direction = (direction+1) % 4;
  }
}


