import CSLib.*;
import java.awt.*;

class MouseDrawer {
  // Draw a mouse at proper location and orientation
  // Author: Allan M. Mickunas, September 22, 1996
  
  private Image[] mousegif = new Image[4];
  private Mouse theMouse;
  private DrawingBox d;
  private int cellW, cellH;  // size of cells in this maze

  public MouseDrawer (Mouse m, MazeDrawer md, DrawingBox d) {
    theMouse = m;
    this.d = d;
    cellW = md.getCellW();
    cellH = md.getCellH();

    // Get the four rodent images.
    for (int i=0; i<4; i++) {
      mousegif[i] = Toolkit.getDefaultToolkit().
                           getImage("images/mouse"+i+".gif");
    }
  }
  

  public void draw () {
    // Draw the mouse
    Point p = theMouse.tellLocation();
    d.drawImage(mousegif[theMouse.tellDirection()],
                p.x*cellW+cellW/3,
                p.y*cellH+cellH/3);
  }
}


