import CSLib.*;
import java.awt.*;
import java.awt.event.*;

public class BodyMass extends ClosableFrame
                      implements ItemListener, ActionListener {

  // Determine Body-Mass-Index and Obesity
  // Author: Deborah Mickunas, October 13, 1996

    // Declare Components
    TextField tHeight, tWeight; 
    Label lIndex, lHigh;
    CheckboxGroup gender;
    Checkbox maleCheck, femaleCheck;

  public BodyMass () {
    super("Body Mass Program");

    // Allocate components.
    tHeight = new TextField(5); 
    tWeight = new TextField(5);
    lIndex = new Label("What is your body-mass-index?     ");
    lHigh = new Label("Is this considered high or not?");
    gender = new CheckboxGroup();
    maleCheck = new Checkbox("Male", gender, true); 
    femaleCheck = new Checkbox("Female", gender, false);

    // Arrange Components
    setLayout(new FlowLayout());
    add(maleCheck);
    add(femaleCheck);
    add(new Label("Height (in meters):"));
    add(tHeight);
    add(new Label("Weight (in kilograms):"));
    add(tWeight);
    add(lIndex);
    add(lHigh);

    setSize(250,200);
    setVisible(true);
  
    // Register Component Listeners
    tHeight.addActionListener(this);
    tWeight.addActionListener(this);
    maleCheck.addItemListener(this);
    femaleCheck.addItemListener(this);
  }
  
  public void itemStateChanged (ItemEvent e) {
    // Respond to Item Events:
    //      1. femaleCheck Checkbox
    //      2. maleCheck Checkbox
    compute();
  }
  
  public void actionPerformed (ActionEvent e) {
    // Respond to Action Events:
    //     1. tHeight TextField
    //     2. tWeight TextField
    compute();
  }

  private void compute () {
    double height = new Double(tHeight.getText()).doubleValue();
    double weight = new Double(tWeight.getText()).doubleValue();
    double bodyMassIndex = weight / (height * height);
    boolean female = 
                (gender.getSelectedCheckbox() == femaleCheck);
  
    lIndex.setText("Your body-mass-index is " + bodyMassIndex);
    if ((bodyMassIndex > 27.8) || 
       female && (bodyMassIndex > 27.3))
         lHigh.setText("This is considered high.");
    else 
         lHigh.setText("This is not considered high.");  
  }
}
