import CSLib.*;
import java.awt.*;
import java.awt.event.*;

public class BodyMass extends ClosableFrame
                      implements ItemListener, ActionListener {

  // Determine Body-Mass-Index and Obesity
  // Author: Deborah Mickunas, October 13, 1996

    // Declare and allocate Components
    TextField 
      tHeight = new TextField(5), 
      tWeight = new TextField(5); 
    Label 
      lIndex = new Label("What is your body-mass-index?     "), 
      lHigh = new Label("Is this considered high or not?");
    CheckboxGroup 
      gender = new CheckboxGroup();
    Checkbox 
      maleCheck = new Checkbox("Male", gender, true), 
      femaleCheck = new Checkbox("Female", gender, false);
    Panel
      p1 = new Panel(),  // line 1
      p2 = new Panel(), // line 2
      p3 = new Panel(); // line 3

  public BodyMass() {
    setTitle("Body Mass Program");
 
  // Set Label properties
    lIndex.setAlignment(Label.CENTER);
    lIndex.setFont(new Font("Helvetica", Font.PLAIN, 14));
    lIndex.setForeground(Color.blue);

    lHigh.setAlignment(Label.CENTER);
    lHigh.setFont(new Font("Helvetica", Font.BOLD, 18));
    lHigh.setForeground(Color.red);

  // Arrange Components 
    setLayout(new GridLayout(5,1));
    p1.add(maleCheck);
    p1.add(femaleCheck);
    add(p1); 
    p2.add(new Label("Height (in meters):"));
    p2.add(tHeight);
    add(p2); 
    p3.add(new Label("Weight (in kilograms):"));
    p3.add(tWeight);
    add(p3);
    add(lIndex);
    add(lHigh);
  
    pack();
    setVisible(true);
  
  // Register Component Listeners
    tHeight.addActionListener(this);
    tWeight.addActionListener(this);
    maleCheck.addItemListener(this);
    femaleCheck.addItemListener(this);
  }
  
  public void itemStateChanged (ItemEvent e) {
    // Respond to Item Events:
    //      1. femaleCheck Checkbox
    //      2. maleCheck Checkbox
    compute();
  }
  
  public void actionPerformed (ActionEvent e) {
    // Respond to Action Events:
    //     1. tHeight TextField
    //     2. tWeight TextField
    compute();
  }

  private void compute () {
    double height = new Double(tHeight.getText()).doubleValue();
    double weight = new Double(tWeight.getText()).doubleValue();
    double bodyMassIndex = weight / (height * height);
    boolean female = 
                (gender.getSelectedCheckbox() == femaleCheck);
  
    lIndex.setText("Your body-mass-index is " + bodyMassIndex);
    if ((bodyMassIndex > 27.8) || 
       female && (bodyMassIndex > 27.3))
         lHigh.setText("This is considered high.");
    else 
         lHigh.setText("This is not considered high.");  
    pack();
  }
  
  public static void main (String[] args) {
    new BodyMass();
  }
}
