import CSLib.*;
import java.awt.*;
import java.awt.event.*;

public class Temperature extends ClosableFrame 
               implements ActionListener {
  
  // Convert temperature from/to Fahrenheit/Centigrade
  // Author: Peter Baranowicz, September 10, 2000
  
  TextField tFahr = new TextField(9),
            tCent = new TextField(9);

  public Temperature () {
    super("Two Way Conversion");

    // Lay out the Components.
    setLayout(new FlowLayout());
    add(new Label("Fahrenheit"));
    add(tFahr); 
    add(new Label("Centigrade"));
    add(tCent);
    pack();
    setVisible(true);
  
    // Register Component Listeners
    tFahr.addActionListener(this);
    tCent.addActionListener(this);
  }
  
  public void actionPerformed (ActionEvent e) {
    // Respond to Action Events:
    //     1. tFahr TextField
    //     2. tCent TextField
  double fahr, cent;
  
    if (e.getSource()==tFahr) {
      fahr = Double.parseDouble(tFahr.getText());
      cent = 5.0 * (fahr - 32.0) / 9.0;
      tCent.setText(cent + ""); 
    }
    else {
      cent = Double.parseDouble(tCent.getText());
      fahr = 9.0 * cent / 5.0 + 32.0;
      tFahr.setText(fahr + "");
    }
  }
}
