import java.awt.*;
import CSLib.*;

public class HilbertCurve {

	InputBox in;
	Hilbert david;
	int order;

  public HilbertCurve () {
		in = new InputBox();
		in.setPrompt("Desired Order:");
    david = new Hilbert(new Point(20,50));
		order = in.readInt();
		david.setOrder(order);
//		david.setVisible(true);
		david.repaint();
  }

	public static void main (String[] args) {
		HilbertCurve h = new HilbertCurve ();
	};
}

class Hilbert extends BaseWindow {

  // Draw Hilbert curves
  // Author: Kathryn Mickunas, May 23, 1996

  int order;
  int scaleFactor;
  Point nwOfWindow;     // drawing area starts here
  Polygon poly;
  int offset;

  Hilbert (Point p) {
    super();
    nwOfWindow = p;
    order = 1;
  }

  void setOrder (int o) {
    // Negative or zero order leads to infinite loop
    order = Math.max(o, 1);
  }

  int curvesize (int ord) {
    return Power.power(2, ord) - 1;
  }

  public void paint (Graphics g) {
		g.clearRect(0,0,getWidth(),getHeight());	
    int windowSize = Math.min(getWidth()-nwOfWindow.x,
                           getHeight()-nwOfWindow.y) - 10;
    scaleFactor =
      (int)((windowSize*1.0) / curvesize(order));
    poly = new Polygon();
    hilbert(order);
    g.drawPolyline(poly.xpoints, poly.ypoints,
                                 poly.npoints);
  }

  static final int NORTH=0, EAST=1, SOUTH=2, WEST=3;

  Point lastpoint;

  void move (int d) {
  // Move one unit in direction d from point lastpoint.

    switch (d) {
      case NORTH:lastpoint.y = lastpoint.y-scaleFactor;
                 break;
      case EAST: lastpoint.x = lastpoint.x+scaleFactor;
                 break;
      case SOUTH:lastpoint.y = lastpoint.y+scaleFactor;
                 break;
      case WEST: lastpoint.x = lastpoint.x-scaleFactor;
                 break;
    }
  }

  void hilbert (
     int i,      // order of Hilbert curve to be drawn
     int facing, // the compass direction we are facing
     int right,  // the compass direction to our right
     int behind, // the compass direction at our back
     int left){  // the compass direction to our left
  // Collect the coordinates of successive points on
  // the Hilbert curve of order i, starting at location
  // lastpoint, oriented as specifed by "local" compass

    if (i == 0)
      poly.addPoint(lastpoint.x, lastpoint.y);
    else {
      hilbert(i-1, left, behind, right, facing);
      move(right);
      hilbert(i-1, facing, right, behind, left);
      move(behind);
      hilbert(i-1, facing, right, behind, left);
      move(left);
      hilbert(i-1, right, facing, left, behind);
    }
  }

  void hilbert (int i) {
  // Draw a Hilbert curve of order i.
    lastpoint = new Point(nwOfWindow);
    hilbert(i, NORTH, EAST, SOUTH, WEST);
  }

}
