import CSLib.*;

class PrintReversed {

static void print (IntList list) {
  OutputBox out = new OutputBox("Reversed input");
  while (list != null) {
    out.println(list.getValue());
    list = list.getTail();
  }
}

static IntList readReverseList () {
  int inputval;
  IntList front = null;

  InputBox in = new InputBox();

  for (;;) {
    inputval = in.readInt();
    if (in.eoi()) break;
    front = new IntList(inputval, front);
  }

  return front;
}

static IntList find (int key, IntList list) {
  while (list != null && list.getValue() != key)
    list = list.getTail();
  return list;
}

static int length (IntList list) {
  int l = 0;
  while (list != null) {
    l++;
    list = list.getTail();
  }
  return l;
}

static IntList nth (IntList list, int n) {
  while (list != null && n > 0) {
    list = list.getTail();
    n--;
  }
  return list;
}

static IntList reverse (IntList list) {
  IntList newList = null;
  while (list != null) {
    // list originally referred to a list x0, ..., xn.
    // Now, it refers to list xi, ..., xn, for some i,
    // and newList refers to the list x(i-1), ..., x0.
    newList = new IntList(list.getValue(), newList);
    list = list.getTail();
  }
  return newList;
}

static IntList readForwardList () {
  int inputval;
  IntList front = null;

  System.out.print("Enter number: ");
  inputval=Keyboard.readInt();

  while (!Keyboard.eof()) {
    front = new IntList(inputval, front);
    System.out.print("Enter number: ");
    inputval=Keyboard.readInt();
  }
  System.out.print("\n");
  return reverse(front);
}

static IntList addToEnd (IntList list, int n)  {
  return reverse(new IntList(n, reverse(list)));
}

public static void main (String[] args) {
  main1();
  //main2();
  //main3();
}

public static void main1 () {
  IntList theList;
  theList = readReverseList();
  print(theList);
}

public static void main2 () {
  IntList list =
    new IntList(17,
      new IntList(616,
        new IntList(10945,
          new IntList(-14, null))));
  if (find(616, list) != null)
    System.out.print("found 616\n");
  if (find(-14, list) != null) 
    System.out.print("found -14\n");
  if (find(17, list) != null)
    System.out.print("found 17\n");
  if (!(find(7, list) != null))
    System.out.print("not found 7\n");
}

public static void main3 () {
  IntList list = readForwardList();
  print(list);
}
}

