import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;

public class CDBaseApplet extends Applet {
  // CD Database Search Applet
  // Author: Samuel N. Kamin, June 1, l996 

  public void init () {
    InputStream is = null;
    CDDatabase theDatabase = null;

    // Open file for stream character reading.
    String name = getParameter("DBURL");
    try {
      is = new URL(name).openStream();
    }
    catch (MalformedURLException e) {
      System.out.println (name + " is not a proper URL");
    }
    catch (IOException e) {
      System.out.println ("Could not open " + name + " for reading.");
    }

    BufferedReader dbreader
          = new BufferedReader(new InputStreamReader(is));

    try {
      theDatabase = new CDDatabase(dbreader);
    }
    catch (IOException e) {
      System.out.println ("An error occurred while reading from " + name);
    }

    // We pass "this" so the QueryManager can place components into "this" 
    // applet.  The QueryManager will be the listener for those components.
    QueryManager qm = new QueryManager(theDatabase, this);
    qm.createForm();
  }
}
