import java.io.*;

public class CDDatabase {
  // CD Database Search
  // Author: Samuel N. Kamin, June 1, l996

  private CDRecord[] cds;
  private int lastQueryResult = -1;
  
  public CDDatabase (BufferedReader r) throws IOException {
    String line = "";
    line = r.readLine();
    int dblength = Integer.parseInt(line);
    cds = new CDRecord[dblength];
    for (int i=0; i<dblength; i++)
      cds[i] = CDRecord.getRecord(r);
  }

  public CDRecord doQuery (Query q) {
    for (int i=0; i<cds.length; i++)
      if (q.check(cds[i])) {
        lastQueryResult = i;
        return cds[i];
      }
    // Matching record not found
    lastQueryResult = -1;
    return null;
  }
  
  public CDRecord redoQuery (Query q) {
    if (lastQueryResult == -1) // Last query failed
      return null;
    for (int i=lastQueryResult+1; i<cds.length; i++)
      if (q.check(cds[i])) {
        lastQueryResult = i;
        return cds[i];
      }
    // Matching record not found
    lastQueryResult = -1;
    return null;
  }
}
