class Query {
  // Query a CD Database
  // Author: Samuel N. Kamin, June 1, l996

  String artist, title;
  boolean 
    caseMatters, // if true, consider case when matching
    prefix; // if true, match only when provided string 
            // is prefix of actual artist or title

  public Query () {
    artist = "";
    title = "";
    caseMatters = false; // case doesn't matter
    prefix = false;      // match anywhere
  }
  
  public void setArtist (String a) { artist = a; }
  public void setTitle (String t) { title = t; }
  void setCase (boolean b) { caseMatters = b; }
  void setPrefix (boolean b) { prefix = b; }
  
  public boolean check (CDRecord cd) {
    return (matches(artist, cd.getArtist()) &&
            matches(title, cd.getTitle()));
  }
  
  private boolean matches (String pat, String str) {
    // Determines whether pat occurs within str.
    // caseMatters and prefix are consulted to determine 
    // how to match.  
    
    if (!caseMatters) {
      pat = pat.toLowerCase();
      str = str.toLowerCase();
      }
    if (prefix) return str.startsWith(pat);
    return (str.indexOf(pat) != -1);
  }
}
