import java.awt.event.*;
import java.awt.*;

class Display extends Canvas implements GameConstants,
                                        ScreenConstants {
  Referee ref;

  public Dimension getPreferredSize () {
    return new Dimension(LINE_LEN, LINE_LEN);
  }

  // Tell me who the Referee is.
  void tellReferee (Referee ref) {
    this.ref = ref;
  }
 
  void reShow () {
    repaint();
  }

  public void paint (Graphics g) {
    for (int i=SQ; i<LINE_LEN; i=i+SQ+LINE) {
      g.drawLine (i, 0, i, LINE_LEN-1);
      g.drawLine (i+1, 0, i+1, LINE_LEN-1);
      g.drawLine (0, i, LINE_LEN-1, i);
      g.drawLine (0, i+1, LINE_LEN-1, i+1);
    }
    for (int col=1; col<9; col++)  
      for (int row=1; row<9; row++) 
        displaySquare(g, row, col);
  }

  private void displaySquare (Graphics g, int row, int col) {
    // Compute upper-left corner of the stone
    int ulx = (col-1)*(SQ+LINE)+(SQ-DIA)/2,
        uly = (row-1)*(SQ+LINE)+(SQ-DIA)/2;
    switch (ref.status(row, col)) {
      case PERSON: g.setColor(Color.pink);
                   g.fillOval(ulx, uly, DIA, DIA);
                   break;
      case PLAYER: g.setColor(Color.black);
                   g.fillOval(ulx, uly, DIA, DIA);
                   break;
      default:  // do nothing
    }
  }
}
