import java.awt.*;
import java.awt.event.*;

abstract class Player implements MouseListener, GameConstants {

  Referee ref;

  Player (Referee ref) {
    this.ref = ref;
  }

  // Formulate a move.
  abstract Point getMove ();

  // Respond to the signal.
  public void mouseClicked (MouseEvent e) {
    // Ignore clicks if it's the person's turn or if the game is done.
    while (ref.whoseTurn() == PLAYER && !ref.gameOver()) 
      ref.makeMove(PLAYER, getMove());
  }
  
  public void mousePressed (MouseEvent e) {}
  public void mouseReleased (MouseEvent e) {}
  public void mouseEntered (MouseEvent e) {}
  public void mouseExited (MouseEvent e) {}
}
