import CSLib.*;

public class Wind {
  //  Calculate and print the wind chill index
  //  for given air temperature and wind speed.
  //  Author: Rachel N. Reingold, January 31, l993
  
  //  The formula is taken from "Windchill" by William
  //  Bosch and L.G. Cobb, UMAP Module 658, COMAP, Inc.,
  //  Lexington, MA, 1984
  
	public void compute () {
    double
      temperature,     // air temperature (deg F)
      windSpeed,       // wind speed (mph)
      windChillIndex;  // wind chill index in deg F, the
                       // equivalent temperature felt
                       // by exposed skin
  
		InputBox in = new InputBox();
    in.setTitle("WIND-CHILL INDEX COMPUTATION");
    in.setPrompt("The temperature (deg F) is: ");
    temperature = in.readDouble();
    in.setPrompt("The wind speed (mph) is: ");
    windSpeed = in.readDouble();
  
    // calculate the wind chill index according to
    // formulas for different ranges of wind speed
  
    if (windSpeed <= 4)      //  little or no wind
      windChillIndex = temperature;
    else if (windSpeed <= 45)   //  moderate wind
      windChillIndex =
        91.4 - (10.45 + 6.69 * Math.sqrt(windSpeed)
                - 0.447 * windSpeed) * (91.4 - temperature)/22.0;
    else                    //  high wind
      windChillIndex = 1.6 * temperature - 55.0;
          
		OutputBox out = new OutputBox();
    out.setTitle("WIND-CHILL INDEX COMPUTATION");
    out.println("The wind-chill index is " + windChillIndex);
  }
  public static void main (String[] args) {
		new Wind().compute();
	}
}
